//+------------------------------------------------------------------+
//|                                                     100Point.mq4 |
//|                                                          Valmars |
//|                                                            ***** |
//+------------------------------------------------------------------+
#property copyright "Valmars"
#property link      "*****"
#include <stdlib.mqh> 
#include <stderror.mqh>
double HighLevel;
double LowLevel;
double Lots=0.1;
int MagicBuy = 0;
int MagicSell = 0;
int Delta = 100;
extern int StopLoss;
extern int TakeProfit=100;
//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init()
  {
   if (MathMod(Bid,100*Point)-50*Point<0) 
         {LowLevel=NormalizeDouble(Bid,Digits-2);
          HighLevel=LowLevel+100*Point;}
   else
         {HighLevel=NormalizeDouble(Bid,Digits-2);
          LowLevel=HighLevel-100*Point;}
Print("LowLevel= ",LowLevel," HighLevel= ",HighLevel); 
   return(0);
  }
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
  {
   return(0);
  }
//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start()
  {
//------    -------------------
string symbol=Symbol();
int ticket;
if (OrdersTotal()>=2)
 if (AccountEquity()-AccountBalance()>0)
  if (Ask-HighLevel>0 || Bid-LowLevel<0)
   {
    CloseAll();
    MagicBuy=0;
    MagicSell=0;
   }
if (Bid-LowLevel>200*Point)
    LowLevel+=100*Point;
if (HighLevel-Ask>200*Point)
    HighLevel-=100*Point;    
Comment("LowLevel= ",LowLevel," HighLevel= ",HighLevel);     
//-----  
if (OrdersTotal()==0) 
   {
    MagicBuy=0;
    if (Ask-HighLevel>0 )
     {
      Print("LowLevel= ",LowLevel," HighLevel= ",HighLevel);
      HighLevel+=100*Point;
      double tp=HighLevel;
      MagicBuy++;
      Buy(symbol,Lots,Ask,3,0,tp,"",MagicBuy);     
      return(0);
     }
    if (Bid-LowLevel<0)
     {
      Print("LowLevel= ",LowLevel," HighLevel= ",HighLevel);
      LowLevel-=100*Point;
      tp=HighLevel;
      MagicBuy++;
      Buy(symbol,Lots,Ask,3,0,tp,"",MagicBuy);     
      return(0);
     }
   } 
else 
  if (OrdersTotal()>=2) 
//   if (CmdExists(OP_SELL,-1))
//    if (CmdExists(OP_BUY,1))
     if (Ask-HighLevel>0)
     {
      HighLevel+=100*Point;
      ticket=OpportunitiOrder(OP_SELL);
      if (ticket>0)
       {
        OrderSelect(ticket,SELECT_BY_TICKET);
        OrderClose(ticket,OrderLots(),Ask,3,CLR_NONE);
        return(0);
       }
      else
       {   
        MagicBuy++;
        Buy(symbol,Lots,Ask,3,0,0,"",MagicBuy);     
        return(0);
       }
     } 
if (Bid-LowLevel<0)
  { 
   LowLevel-=100*Point;
   ticket=OpportunitiOrder(OP_BUY);
      if (ticket>0)
       {
        OrderSelect(ticket,SELECT_BY_TICKET);
        OrderClose(ticket,OrderLots(),Bid,3,CLR_NONE);
        return(0);
       }
      else
       {   
        if (CmdExists(OP_BUY,1) != 0)
         {
          ticket=CmdExists(OP_BUY ,1);
          OrderSelect(ticket,SELECT_BY_TICKET); 
          if (OrderTakeProfit()!=0) 
            OrderModify(ticket,OrderOpenPrice(),0,0,0,CLR_NONE);
          MagicSell--;
          Sell(symbol,Lots,Bid,3,0,0,"",MagicSell);
          return(0);
         }
       }  
   }
 } 
//----------------------------------------------------------------------
// bool CmdExists() function                                           |
//---------------------------------------------------------------------- 
int CmdExists(int cmd, int MAGIC)
 { int result=0;
   int total=OrdersTotal();  
   for (int i=total-1;i>=0;i--)       
	 { 	
     if (!(OrderSelect(i, SELECT_BY_POS, MODE_TRADES))) 
      {
       int error_code = GetLastError();
       Print("Error OrderSelect function: ", ErrorDescription(error_code), " (", error_code, ")");
       return ;
      }
	  if ( OrderSymbol()!=Symbol() || MAGIC != OrderMagicNumber())     	
		continue;                        
  	  else
      if (OrderType() == cmd) result=OrderTicket();    //    
    }  
 return(result);
 } 
//----------------------------------------------------------------------
// bool CloseAll() function                                            |
//----------------------------------------------------------------------
bool CloseAll()
 {
  int total=OrdersTotal(); 
   for (int i=total-1;i>=0;i--)       
	 { 	
     if (!(OrderSelect(i, SELECT_BY_POS, MODE_TRADES))) 
      {
       int error_code = GetLastError();
       Print("Error OrderSelect function: ", ErrorDescription(error_code), " (", error_code, ")");
       return(false);
      }
	  if (OrderSymbol() != Symbol())     	
		continue;                        
     if (OrderMagicNumber()>0)
      {
       double price=NormalizeDouble(Ask,Digits);
       OrderClose(OrderTicket(),OrderLots(),price,3);
      }
     if (OrderMagicNumber()<0)
      {
       price=NormalizeDouble(Bid,Digits);
       OrderClose(OrderTicket(),OrderLots(),price,3);
      }
    }
  return(true);   
 }
//----------------------------------------------------------------------
// bool OpportunitiOrder() function                                            |
//---------------------------------------------------------------------- 
int OpportunitiOrder(int cmd)
   {
    int result=0; 
    int total=OrdersTotal(); 
    for (int i=total-1;i>=0;i--)       
	  { 	
      if (!(OrderSelect(i, SELECT_BY_POS, MODE_TRADES))) 
       {
        int error_code = GetLastError();
        Print("Error OrderSelect function: ", ErrorDescription(error_code), " (", error_code, ")");
        return(false);
       }
	   if (OrderSymbol() != Symbol())     	
		 continue;
		if (cmd==OrderType() && MathAbs(OrderOpenPrice()-Bid)<20*Point)
		  {result=OrderTicket();break;}
	   }	
	  return(result);
	 } 
//+------------------------------------------------------------------+
//| Buy() function                                                   |
//+------------------------------------------------------------------+
int Buy(string symbol, double Lots, double price, int slip, double sl, double tp, string comment="", int magic=0) {

  price = NormalizeDouble(price, Digits);
  sl = NormalizeDouble(sl, Digits);
  tp = NormalizeDouble(tp, Digits);
  int ticket = OrderSend(symbol, OP_BUY, Lots, price, slip, sl, tp, comment, magic,0,Aqua);
  if (ticket <= 0) 
   {int error_code = GetLastError();
  Print("Error opening BUY order: ", ErrorDescription(error_code), " (", error_code, ")");
  RefreshRates( );return (0);
   }
   else return (ticket);}
//+------------------------------------------------------------------+
//| Sell() function                                                  |
//+------------------------------------------------------------------+
int Sell(string symbol, double Lots, double price, int slip, double sl, double tp, string comment="", int magic=0) {

  price = NormalizeDouble(price, Digits); 
  sl = NormalizeDouble(sl, Digits);
  tp = NormalizeDouble(tp, Digits);
  
  int ticket = OrderSend(symbol, OP_SELL, Lots, price, slip, sl, tp, comment, magic,0,Red );
  if (ticket <= 0) 
   {int error_code = GetLastError();
  Print("Error opening SELL order: ", ErrorDescription(error_code), " (", error_code, ")");
  RefreshRates( );return (0);
   }
   else return (ticket);}

//+------------------------------------------------------------------+		                                        